<template>
<div id="edp3-header">
  <div id="header" class="edp-header">
    <div class="edp-header__container container">
      <!-- Hamburger menu button for mobile view -->
      <a
        href="#"
        class="edp-header__menu-btn menu--btn"
        type="button"
        data-toggle="collapse"
        data-target="#navbar-toggle"
        aria-controls="navbarTogglerDemo02"
        aria-expanded="false"
        aria-label="Toggle navigation"
        @click="menuCollapsed = !menuCollapsed"
      >
        <span
          class="fas"
          :class="{'fa-bars': menuCollapsed, 'fa-times': !menuCollapsed}"
        />
      </a>
      <div class="edp-header__content region region-header">
        <!-- Branding -->
        <div id="block-edp3-branding" class="edp-header__branding">
          <app-link class="site-branding__logo" :path="`/${$i18n.locale}`">
            <img class="edp-logo ml-3" src="@/assets/img/edplogo.png" alt="European data portal logo">
          </app-link>
          <div class="site-branding__text">
            <div class="site-branding__name">
              <app-link :path="`/${$i18n.locale}`">
                {{ $t('message.header.european') }} <strong>{{ $t('message.header.dataPortal') }}</strong>
              </app-link>
            </div>
          </div>
        </div>
        <!-- Search bar -->
        <div id="block-search" class="edp-header__search-bar">
          <div class="clearfix">
            <search-bar></search-bar>
          </div>
        </div>
        <!-- Language box -->
        <div id="block-languageswitcher" class="edp-header__language-box block-language" role="navigation">
          <div class="input-group">
            <language-selector></language-selector>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- Navigation bar -->
  <nav class="edp-nav navbar-expand-lg">
    <div id="navbar-toggle" class="second-level-open collapse navbar-collapse">
      <div class="edp-menu-container container">
        <div class="region region-primary-menu">
          <nav role="navigation"
            id="block-edp3-main-menu"
            class="menu--main">
            <ul class="edp-menu menu navbar-nav">
              <!-- Home -->
              <li class="edp-menu__item edp-menu__item--home nav-item">
                <app-link :path="`/${$i18n.locale}`">
                  <span class="edp-menu__home-text">Home</span>
                </app-link>
              </li>
              <!-- COVID-19 -->
              <li class="edp-menu__item nav-item dropdown position-static">
                <app-link :path="`/${$i18n.locale}/covid-19/overview`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <span>{{ $t('message.header.navigation.covid-19.title') }}</span>
                </app-link>
                <form class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/covid-19/overview`">
                        {{ $t('message.header.navigation.covid-19.overview') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/covid-19/datasets`">
                        {{ $t('message.header.navigation.covid-19.datasets') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/covid-19/stories`">
                        {{ $t('message.header.navigation.covid-19.stories') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/covid-19/initiatives`">
                        {{ $t('message.header.navigation.covid-19.initiatives') }}
                      </app-link>
                    </li>
                  </ul>
                </form>
              </li>
               <!-- Data -->
              <!-- Since it is known that this application lies within /data/. -->
              <!-- just assume this path is active instead of deciding it dynamically. -->
              <!-- Put the active class as appropriate when this component is put in another app. -->
              <li class="edp-menu__item nav-item dropdown position-static active">
                  <app-link :path="`/data/datasets?locale=${$i18n.locale}`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span>{{ $t('message.header.navigation.data.title') }}</span>
                  </app-link>
                <div class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/data/datasets?locale=${$i18n.locale}`">
                      {{ $t('message.header.navigation.data.datasets') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/sparql-manager/${$i18n.locale}/`">
                      {{ $t('message.header.navigation.data.sparqlsearch') }}
                      </app-link>
                      </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/catalogue-statistics/?locale=${$i18n.locale}`">
                      {{ $t('message.header.navigation.data.statistics') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="{name: 'Dashboard', query: { locale: $route.query.locale }}" class="active">
                      {{ $t('message.header.navigation.data.metadataQuality') }}
                      </app-link>
                    </li>
                </ul>
                </div>
              </li>
              <!-- Impact & Studies -->
              <li class="edp-menu__item nav-item dropdown position-static">
                <app-link :path="`/${$i18n.locale}/impact-studies/overview`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <span>{{ $t('message.header.navigation.impactStudies.title') }}</span>
                </app-link>
                <form class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/overview`">
                        {{ $t('message.header.navigation.impactStudies.overview') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/country-insights`">
                        {{ $t('message.header.navigation.impactStudies.countryInsights') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/open-data-impact`">
                        {{ $t('message.header.navigation.impactStudies.opendataimpact') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/open-data-maturity`">
                        {{ $t('message.header.navigation.impactStudies.opendatamaturity') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/studies`">
                        {{ $t('message.header.navigation.impactStudies.studies') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/use-cases`">
                        {{ $t('message.header.navigation.impactStudies.useCases') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/impact-studies/tell-us-your-story`">
                        {{ $t('message.header.navigation.impactStudies.tellUsYourStory') }}
                      </app-link>
                    </li>
                  </ul>
                </form>
              </li>
              <!-- Training -->
              <li class="edp-menu__item nav-item dropdown position-static">
                <app-link :path="`/${$i18n.locale}/training/what-open-data`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <span>{{ $t('message.header.navigation.training.title') }}</span>
                </app-link>
                <form class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/training/what-open-data`">
                        {{ $t('message.header.navigation.training.whatIsOpenData') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/training/elearning`">
                        {{ $t('message.header.navigation.training.elearning') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/training/licensing-assistant`">
                        {{ $t('message.header.navigation.training.licensingAssistant') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/training/data-providers-guide`">
                        {{ $t('message.header.navigation.training.dataProvidersGuide') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/training/more-training-material`">
                        {{ $t('message.header.navigation.training.moreTrainingMaterial') }}
                      </app-link>
                    </li>
                  </ul>
                </form>
              </li>
              <!-- News & Events -->
              <li class="edp-menu__item nav-item dropdown position-static">
                <app-link :path="`/${$i18n.locale}/news-events/news`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <span>{{ $t('message.header.navigation.newsEvents.title') }}</span>
                </app-link>
                <form class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/news-events/news`">
                        {{ $t('message.header.navigation.newsEvents.news') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/news-events/events`">
                        {{ $t('message.header.navigation.newsEvents.events') }}
                      </app-link>
                    </li>
                  </ul>
                </form>
              </li>
              <!-- About -->
              <li class="edp-menu__item nav-item dropdown position-static">
                <app-link :path="`/${$i18n.locale}/about/european-data-portal`" class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <span>{{ $t('message.header.navigation.about.title') }}</span>
                </app-link>
                <form class="edp-menu__dropdown dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                  <ul class="edp-menu__dropdown-list">
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/about/european-data-portal`">
                        {{ $t('message.header.navigation.about.europeanDataPortal') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/about/documentation`">
                        {{ $t('message.header.navigation.about.documentation') }}
                      </app-link>
                    </li>
                    <li class="edp-menu__dropdown-list-item">
                      <app-link :path="`/${$i18n.locale}/about/be-harvested-us`">
                        {{ $t('message.header.navigation.about.beHarvestedByUs') }}
                      </app-link>
                    </li>
                  </ul>
                </form>
              </li>
            </ul>
          </nav>
        </div>
      </div>
    </div>
  </nav>
</div>
</template>

<script>
// import Actions and Getters from Store Module
import { mapGetters } from 'vuex'
/* eslint-disable */
import AppLink from './AppLink';
import LanguageSelector from "./LanguageSelector";
import SearchBar from "./SearchBar";
import { getTranslationFor, truncate } from '../utils/helpers';

export default {
  name: 'topnav',
  components: {
    languageSelector: LanguageSelector,
    searchBar: SearchBar,
    appLink: AppLink,
  },
  data() {
    return {
      rootURL: 'https://www.europeandataportal.eu/',
      showDatasets: false,
      showDatasetDetails: false,
      showDatasetDetailsCategories: false,
      showDatasetDetailsSimilarDatasets: false,
      showDatasetDetailsActivityStream: false,
      showCatalogues: false,
      showCatalogueName: false,
      menuCollapsed: true,
    };
  },
  computed: {
    // import store-getters
    ...mapGetters('datasetDetails', [
      'getID',
      'getTitle',
    ]),
    ...mapGetters('catalogues', [
      'getCatalogues',
    ]),
    currentRoute() {
      return this.$store.getters.getCurrentRoute;
    },

  },
  methods: {
    getTranslationFor,
    truncate,
    getCatalogTitle(catalogID) {
      for(const catalog of this.getCatalogues) {
        if (catalog.id === catalogID) return catalog.title;
      }
    },
  },
  watch: {
    currentRoute: function() {
      this.showDatasets = this.$router.currentRoute.name === 'Datasets' && this.$route.query.showcataloguedetails !== 'true';
      this.showDatasetDetails = this.$router.currentRoute.name === 'DatasetDetails';
      this.showDatasetDetailsCategories = this.$router.currentRoute.name === 'DatasetDetailsCategories';
      this.showDatasetDetailsSimilarDatasets = this.$router.currentRoute.name === 'DatasetDetailsSimilarDatasets';
      this.showDatasetDetailsActivityStream = this.$router.currentRoute.name === 'DatasetDetailsActivityStream';
      this.showCatalogues = this.$router.currentRoute.name === 'Catalogues';
      this.showCatalogueName = this.$router.currentRoute.name === 'Datasets' && this.$route.query.showcataloguedetails === 'true';
    },
  },
};

</script>

<style lang="scss">
  $edp3-primary: #202272;
  $edp3-secondary: #1986dc;
  // Styles shared across this component and child components
  #edp3-header {
    .edp-btn.edp-btn--primary {
      border: none;
      // padding: .375rem .75rem;
      background-color: $edp3-primary;
      border-color: $edp3-primary;
      color: #fff;
      cursor: pointer;
      transition: color .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out;

      &:hover {
        background-color: #196fd2;
        border-color: #196fd2;
        color: #fff;
        cursor: pointer;
      }
    }
  }

</style>

<style lang="scss" scoped>
@import '../../node_modules/bootstrap/scss/bootstrap.scss';
@import '@/styles/header.scss';

$edp3-primary: #202272;
$edp3-secondary: #1986dc;
$edp3-active: #196FD2;

#edp3-header #header #block-edp3-branding {
    padding: 16px 10px 14px 0px;
    float: left;
    margin-left: -6px;
}

#navbar-toggle {
  background-color: $edp3-primary;
  // height: 48px;
  position: sticky;
  z-index: 99;
  top: 0;
  margin-bottom: 60px;
}

// .show {
//   background-color: #1986dc;
//   color: #dff3ff;
//   display: inline-block;
//   cursor: pointer;
//   padding: 11px 15px;
//   width: auto;
//   text-align: center;
//   display: block;
//   text-decoration: none;
// }

#edp3-header {
  display: initial;
  // Navigation bar
  .edp-nav {
    display: initial;
  }

  .edp-menu {
    // Navigation bar/first-level menu
    &__item {
      list-style-type: none;
      list-style-image: none;
      margin: 0;
      padding: 0;
      flex: 1 1 auto;

      &.active {
        background-color: $edp3-active;

        // Always collapse the item with the active class
        .edp-menu__dropdown {
          display: block!important;
          z-index: 0;
        }

      }

      &.show {
        background-color: $edp3-secondary;
      }

      // Home button gets special styling
      &--home {
        flex: 0;

        .edp-menu__home-text {
          line-height: 1.9;
          display: none;
        }

        a {
          display: inline-block;
          height: 48px;
        }

        a::before {
            display: inline-block;
            content: "\f015";
            font-family: "Font Awesome 5 Free";
            font-weight: 900;
            font-size: 14px;
        }
      }

      a {
        color: #dff3ff;
        display: inline-block;
        cursor: pointer;
        padding: 11px 15px;
        width: auto;
        text-align: center;
        display: block;
        text-decoration: none;

        &:hover {
          color: white;
        }
      }

      // Override bootstrap dropdown arrow
      .dropdown-toggle::after {
        font-family: "Font Awesome 5 Free";
        content: "\F0D7";
        display: inline-block;
        border-top: 0.0em solid;
        border-right: 0.0em solid transparent;
        border-bottom: 0;
        border-left: 0.0em solid transparent;
        font-weight: 900;
        margin-left: 10px;
        vertical-align: 0;
      }
    }

    // Second-level/dropdown menu styling
    &__dropdown {
      z-index: 9;
      background-color: $edp3-secondary;
      position: absolute;
      left: 0;
      right: 0;
      width: 100%;
      padding: 5px 5px 0 5px;
      min-height: 40px;
      text-align: center;
      margin: 0;

      border: none!important;
      border-radius: 0;
      transform: none!important;
      top: auto!important;
      left: auto!important;
    }

    &__dropdown-list {
      display: flex;
      flex-wrap: wrap;
      justify-content: center;
      padding: 0;
    }

    &__dropdown-list-item {
      list-style-type: none;
      list-style-image: none;
      flex: 0 1 auto;

      a {
        display: inline-block;
        padding: 5px 15px;
        margin-bottom: 5px;
        border: 1px solid $edp3-primary;
        border-radius: 4px;
        color: #ffffff;
        background-color: $edp3-primary;
        text-align: center;
        text-decoration: none;

        &.active, &:hover {
          border-color: #ffffff;
          color: #ffffff;
          background-color: transparent;
        }
      }

      &:not(:last-child):after {
        // When Vue renders a component, it trims whitespaces in templates.
        // See https://vue-loader.vuejs.org/options.html#compileroptions
        // However, the master header uses whitespaces in between its list
        // items (instead of using paddings or margins) so we do this:
        content: "\00a0"; // whitespace character
      }
    }
  }

  // Mobile view
  @media only screen and (max-width: 990px) {
    .edp-menu-container {
      padding-left: 0;
      padding-right: 0;
    }

    .edp-menu {
      // Menu styling
      overflow: hidden;
      height: calc(100vh - 81px);
      max-height: 100%;
      overflow-y: scroll;
      border-top: 1px solid #196fd2;
      padding-left: 15px;
      padding-right: 15px;
      padding-bottom: 50px;
      align-items: start;

      &__item {
        width: 100%;

        &.show {
          background-color: transparent;
        }

        &.active {
          // Highlights the current 'active' route
          // Special styling for mobile only
          padding-left: 15px;
          padding-right: 15px;
          background-color: $edp3-active;

          .edp-menu__dropdown {
            padding: 5px 15px 0 15px;
          }
        }

        & > a {
          padding-left: 0;
          text-align: left;
          font-weight: bold;
        }

        &:not(:last-child) {
          border-bottom: 1px solid $edp3-secondary;
        }

        &--home {
          flex: 0;

          .edp-menu__home-text {
            display: inline-block;
          }

          a::before {
            margin-right: 5px;
          }
        }
      }

      &__dropdown {
        text-align: left;
        position: relative;
        display: block;
        background-color: transparent;
        padding: 0 0 10px 0;

        // Override bootstrap's attempt to apply dropdown menu styling
        // when on mobile view mode
        position: relative!important;
        will-change: initial!important;
        top: auto!important;
        left: auto!important;
        transform: none!important;
      }

      &__dropdown-list {
        display: block;
      }

      &__dropdown-list-item {
        a {
          border: 0;
          margin: 0;
          padding: 11px 15px;
          color: #dff3ff;
          background-color: transparent;
          text-align: left;
          width: 100%;

          &.active, &:hover {
            color: white;
          }

          &.active {
            border: 1px solid white;
          }
        }

       &:not(:last-child):after {
          content: "";
        }
      }
    }

    .edp-header {
      position: sticky;
      top: 0;
      z-index: 101;
      border-bottom: 1px solid #D5D6F7;

      &__menu-btn {
        display: block;
      }

      &__search-bar {
        /deep/ .form-control {
          display: none;
        }

        /deep/ .btn-search {
          height: 40px;
          border-radius: 4px!important;
        }
      }
    }
  }
}

</style>
